;;This file is part of Project Thing.
;;
;;Project Thing is free software: you can redistribute it and/or modify
;;it under the terms of the GNU General Public License as published by
;;the Free Software Foundation, either version 3 of the License, or
;;(at your option) any later version.
;;
;;Project Thing is distributed in the hope that it will be useful,
;;but WITHOUT ANY WARRANTY; without even the implied warranty of
;;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;GNU General Public License for more details.
;;
;;You should have received a copy of the GNU General Public License
;;along with Project Thing.  If not, see <https://www.gnu.org/licenses/>.

;;
;;Animation system
;;
.include "animation_system.h.s"

animation_init::
    ret


;;Updates the current animation
;; INPUT: IX
animation_update::

    call calculateAnimState
    ld a, e_animation_state(ix)

    cp b

    jr z, _continue_anim

_changeAnimState:
    ld e_animation_state(ix), b

    call getAnimPtr
    ld e_animation_ptr_l(ix), l
    ld e_animation_ptr_h(ix), h

    jr _return2anim

_continue_anim:
    ld l, e_animation_ptr_l(ix) ;;Next anim Sprite
    ld h, e_animation_ptr_h(ix)

_return2anim:
    ld c, (hl)  ;;loads the next site to bc
    inc hl
    ld b, (hl)
    inc hl      ;;Modifies ptr to next anim

    ld a, c     ;;Checks to see if the current ptr to sprite == nullptr and then resets animation if true
    or b
    jr z, _reset_anim

    ld e_animation_ptr_l(ix), l
    ld e_animation_ptr_h(ix), h


    ld e_sprite_l(ix), c ;; store next sprite on the sprite to render
    ld e_sprite_h(ix), b


    ret

_reset_anim:
    ld a, (hl)
    inc hl
    ld h, (hl)
    ld l, a

    jr _return2anim



;; AnimStates
;; 0000 - idle
;; 0001 - left
;; 0010 - right
;; 0011 - ---
;; 0100 - jump in place
;; 0101 - jump left
;; 0110 - jump right
;; 1000 - crouch
;; 1001 - falling left
;; 1010 - falling right

;;Reads current speed and animstate to determine which animation state the player should have
;;IX entity
calculateAnimState:
    ld b, #0

    ld a, e_vx(ix)
    or a
    jr z, _vxzero
_vxnozero:
    jp m, _vxneg
_vxpos:
    set 1, b
    jr _vxzero
_vxneg:
    set 0, b
_vxzero:

    ld a, e_vy(ix)
    or a
    jr z, _vyzero
_vynozero:
    jp m, _vyneg
_vypos:
    jr _vyzero
    set 3, b
    jr _vyzero
_vyneg:
    set 2, b
_vyzero:

_crouched:
    ld a, e_h(ix)
    cp #32
    jr z, _fin
    set 3, b
_fin:
    ret