;;This file is part of Project Thing.
;;
;;Project Thing is free software: you can redistribute it and/or modify
;;it under the terms of the GNU General Public License as published by
;;the Free Software Foundation, either version 3 of the License, or
;;(at your option) any later version.
;;
;;Project Thing is distributed in the hope that it will be useful,
;;but WITHOUT ANY WARRANTY; without even the implied warranty of
;;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;GNU General Public License for more details.
;;
;;You should have received a copy of the GNU General Public License
;;along with Project Thing.  If not, see <https://www.gnu.org/licenses/>.

;;
;;animations
;;
.include "assets.h.s"
.include "entity_manager.h.s"


_animations_array:
    .dw _thing_idle
    .dw _thing_walking_left ;;left
    .dw _thing_walking_right
    .dw nullptr
    .dw _thing_jumping
    .dw _thing_jumping_left ;;jump left
    .dw _thing_jumping      ;;jump right
    .dw nullptr
    .dw _thing_agachado     ;;thing crouched    
    .dw _thing_jumping_left     ;;fall right
    .dw _thing_jumping

;; AnimStates
;; 0000 - idle
;; 0001 - left
;; 0010 - right
;; 0011 - ---
;; 0100 - jump in place
;; 0101 - jump left
;; 0110 - jump right
;; 0111 - ---
;; 1000 - crouch
;; 1001 - falling left
;; 1010 - falling right


;;INPUT: b
;;DESTROYS: A, HL
getAnimPtr::
    ld hl, #_animations_array
    ld a, b
    add a
    add l
    ld l, a
    adc h
    sub l
    ld h, a

    ld a, (hl)
    inc hl
    ld h, (hl)
    ld l, a

    ret

_thing_walking_right::
    .dw _personajes_2
    .dw _personajes_1
    .dw _personajes_0
    .dw nullptr
    .dw _thing_walking_right

_thing_walking_left::
    .dw _personajesLeft_0
    .dw _personajesLeft_1
    .dw _personajesLeft_2
    .dw nullptr
    .dw _thing_walking_left

_thing_idle::
    .dw _personajes_2
    .dw _personajes_2
    .dw _personajes_5
    .dw _personajes_5
    .dw nullptr
    .dw _thing_idle

_thing_jumping::
    .dw _personajes_4
    .dw nullptr
    .dw _thing_jumping

_thing_jumping_left::
    .dw _personajesLeft_4
    .dw nullptr
    .dw _thing_jumping_left

_thing_agachado::
    .dw _Thing_agachado1
    .dw nullptr
    .dw _thing_agachado