;;This file is part of Project Thing.
;;
;;Project Thing is free software: you can redistribute it and/or modify
;;it under the terms of the GNU General Public License as published by
;;the Free Software Foundation, either version 3 of the License, or
;;(at your option) any later version.
;;
;;Project Thing is distributed in the hope that it will be useful,
;;but WITHOUT ANY WARRANTY; without even the implied warranty of
;;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;GNU General Public License for more details.
;;
;;You should have received a copy of the GNU General Public License
;;along with Project Thing.  If not, see <https://www.gnu.org/licenses/>.

;;
;; CONTROL DE COLISIONES CON PARED
;;

.include "cpctelera.h.s"
.include "entity_manager.h.s"
.include "physics_system.h.s"

;border_right: .db #0 
;border_left: .db #3


check_collision_wall::
		
	ld a, e_vx(ix)
	cp #0

	jp m, check_collision_left

	call check_collision_right
	;call check_collision_left	

	ret

check_collision_right:
	
	ld a, #screen_width + 1
	sub e_w(ix)
	ld c, a

	ld a, e_x(ix)
	add e_vx(ix)
	cp c

	jr c, no_collision_right

	ld c, #1

	ret

	no_collision_right:

	ld b, a
	ld c, #0

	ret

check_collision_left:
	
	ld a, #screen_width + 1
	sub e_w(ix)
	ld c, a

	ld a, e_x(ix)
	add e_vx(ix)
	cp c

	jr c, no_collision_left

	ld c, #1

	ret

	no_collision_left:

	ld b, a
	ld c, #0

	ret


check_enemy_right:
	
	;check_X:
	;; Comprobamos eje X
	;; Enemigo
	ld b, e_x(ix)

	ld__ixh_d
    ld__ixl_e

	;;Player
	ld a, e_x(ix)
	add e_w(ix)

	sub b

	;; x flecha = x player + w_x = 0	
	jr z, check_collision_Y

	;; x flacha > x palyer + w_x = carry
	jp m, no_collision

	jp check_enemy_bottom

	no_collision:

	call end_collision_player

	jp end_check_enemy_right

	check_enemy_bottom:
	;; x flecha < x player + w_x = no carry
	ld a, e_x(ix)

	sub b

	;; x flecha < x player + w_x = no carry
	jp m, check_collision_Y

	jp end_collision_player

	check_collision_Y:

	call check_Y

	jp end_check_enemy_right
		
	end_check_enemy_right:

	ret

check_enemy_left:
	
	;check_X:
	;; Comprobamos eje X
	;; Enemigo
	ld b, e_x(ix)
	inc b
	inc b
	inc b

	ld__ixh_d
    ld__ixl_e

	;;Player
	ld a, e_x(ix)

	sub b

	;; x flecha = x player = 0	
	jr z, check_collision_Y_left

	;; x flacha > x palyer + w_x = carry
	jp m, check_left_enemy_bottom

	jp no_collision_enemy_left

	no_collision_enemy_left:

	call end_collision_player

	jp end_check_enemy_left

	check_left_enemy_bottom:
	;; x flecha < x player + w_x = no carry
	ld a, e_x(ix)
	add e_w(ix)

	sub b

	;; x flecha < x player + w_x = no carry
	jp m, end_collision_player

	jr check_collision_Y_left

	check_collision_Y_left:

	call check_Y

	jp end_check_enemy_left
		
	end_check_enemy_left:

	ret


check_enemy_up:

	;ld (bomb_entity), ix
	call man_entity_getInt_Pend
	ld (player_entity), de
	player_entity = . + 2
	ld iy, #0x0000

	;; Bomba
	ld a, e_y(ix)
	add e_h(ix)

	;; Player
	ld b, e_y(iy)
	sub b

	jr z, check_width_player

	jp nc, check_width_player

	jp end_check_enemy_up

	check_width_player:

	;; Bomba
	ld a, e_x(ix)
	;add e_w(ix)

	;; Player
	ld b, e_x(iy)
	cp b	

	jr z, collision_player_up ;; Esta dentro

	jp m, check_right_site_bomb

	jr nc, check_right_site;; paso siguiente comprobacion

	;jp end_check_enemy_up ;; Si da positivo, está fuera

	check_right_site_bomb:

	add e_w(ix)
	cp b

	jr z, end_check_enemy_up

	jr nc, collision_player_up

	jp end_check_enemy_up

	check_right_site:

	;; Player
	ld a, e_x(iy)
	add e_w(iy)

	;; Bomba
	ld b, e_x(ix)
	sub b

	jr nc, collision_player_up ;; SI es positivo esta dentro

	jp end_check_enemy_up

	collision_player_up:

	ld a, #01

	ret

	end_check_enemy_up:

	ld a, #00

	ret


check_collision_player::
	
	ld (ptr_actual_enemy), ix

	ld a, e_state(ix)
	cp #enemy_noIA_bomb

	jr nz, enemy_no_bomb

	call check_enemy_up

	jp end_check_collision_player

	enemy_no_bomb:

	call man_entity_getInt_Pend

	ld a, e_vx(ix)
	cp #0

	jp m, right_enemy

	call check_enemy_left

	jp end_check_collision_player

	right_enemy:

	call check_enemy_right

	jp end_check_collision_player

	;; x flacha > x palyer = carry
	;jr c, check_Y
	


	;jr check_Y

	;continue_X:

	;ld a, e_x(ix)
	;sub b

	;jp m, end_collision_player

	;jr collision_player

	check_Y:

	call reset_ptr

	ld (ptr_actual_enemy), ix

	call man_entity_getInt_Pend

	;; Enemigo
	ld b, e_y(ix)

	ld__ixh_d
    ld__ixl_e

    ;; Player
    ld a, e_y(ix)
    sub b

    jp m, continue

    jr end_collision_player

    continue:

    ld a, e_y(ix)
    ld c, e_h(ix)
    add a, c
    sub b

    jp m, end_collision_player

	jr collision_player

	collision_player:

	ld a, #1

	call reset_ptr

	ret

	end_collision_player:

	ld a, #0

	call reset_ptr

	end_check_collision_player:

	ret

reset_ptr:
	
	ptr_actual_enemy = . + 1
	ld de, #ptr_actual_enemy

	ld__ixh_d
    ld__ixl_e

ret