;;This file is part of Project Thing.
;;
;;Project Thing is free software: you can redistribute it and/or modify
;;it under the terms of the GNU General Public License as published by
;;the Free Software Foundation, either version 3 of the License, or
;;(at your option) any later version.
;;
;;Project Thing is distributed in the hope that it will be useful,
;;but WITHOUT ANY WARRANTY; without even the implied warranty of
;;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;GNU General Public License for more details.
;;
;;You should have received a copy of the GNU General Public License
;;along with Project Thing.  If not, see <https://www.gnu.org/licenses/>.

;;
;; SISTEMA DE ENEMIGOS
;;

.include "cpctelera.h.s"
.include "entity_manager.h.s"
.include "collision.h.s"
.include "timer.h.s"
.include "assets.h.s"
.include "render_system.h.s"
;.include "ai_control_system.h.s"
;.include "game_manager.h.s"

;.globl man_delete_entity
;.globl man_entity_refresh_pend
;.globl max_entities

;.globl man_pointer_first_enemy
;.globl man_entity_getNumEnemies
;.globl man_entity_setNumEntities
;.globl man_entity_getNumEntitites

.globl ai_control_stand_by
.globl set_standby_delay_one

.globl start_game
.globl reset_tilemap_ptr
.globl reset_MaxSize



;;  _x, _y, _h, _w, _vx, _vy , _sprite, _lastPosPtr, _state, _life, _ai_state, _animation_ptr, _animation_state, _draw
DefineEntity proyectilDerecha, 78, 0, 5, 4, -1, 0, _Espada1, 0xFF11, 3, -1, #ai_no_ai, nullptr, anim_no_anim, on
DefineEntity proyectilIzquierda, 0, 0, 5, 4, 1, 0, _Espada1, 0xFF11, 3, -1, #ai_no_ai, nullptr, anim_no_anim, on

;max_num_entities = 3
;entity_size_enemies == 10
;num_entities: .db #0
;last_elem_pointer: .dw enemy_array
;enemy_array:
;DefineEntityArray enemy_array, max_num_entities

;; Variables para generar enemigos en intervalo de tiempo
cont_right: .db #0 				;; Se le asigna el valor que se le ha asignado anteriormente a la variable cont_time_enemies, y se va debrementando
cont_left: .db #0
 							;; Cuando la variables llegue a 0, se generará otro enemigo y se volverá a inicializar
cont_time_enemies: .db #0	;; Intervalo de tiempo en la generación de cada enemigo (en teoría cuando vaya pasando de nivel, este valor será menor)
cont_time_enemies_left: .db #0

;; Movimiento del proyectil
proyectil_speed: .db #0
proyectil_speed_left: .db #0


;; Devuelve la velocidad del proyectil 
;; REGISTROS ALTERADOS: A
get_proyectil_speed::
	
	ld a, (proyectil_speed)

	ret

get_proyectil_speed_left::

	ld a, (proyectil_speed_left)
	
	ret

;; Inicializamos las variables contador y velocidad del proyectil según el nivel
;; REGISTROS ALTERADOS: AF, HL, DE, BC
init_enemies_level::

	call set_timer

	call get_actual_level
	cp #1
	jr z, level_1
	cp #2
	jr z, level_2
	cp #3
	jr z, level_3
	cp #4
	jr z, level_4
	cp #5
	jr z, level_5
	cp #6
	jr z, level_6
	cp #7
	jp z, level_7

	jp switch_end

	level_1:

	;; Solo moverse / NO ENEMIGOS
	;xor a
	;ld (cont_right), a
	;ld a, #40
	;ld (cont_time_enemies), a

	;; EL enemigo se mueve de 4 en 4 píxeles
	;ld a, #-2
	;ld (proyectil_speed), a
	

	jp fin_init_enemies

	level_2:

	;; Solo felchas derecha

	xor a
	ld (cont_right), a
	ld a, #25
	ld (cont_time_enemies), a

	;; EL enemigo se mueve de 4 en 4 píxeles
	ld a, #-2
	ld (proyectil_speed), a

	jp fin_init_enemies

	level_3:

	;; Flechas ambos lados

	xor a
	ld (cont_right), a
	ld (cont_left), a
	ld a, #20
	ld (cont_time_enemies), a
	ld a, #35
	ld (cont_time_enemies_left), a
	
	;; EL enemigo se mueve de 4 en 4 píxeles
	ld a, #-2
	ld (proyectil_speed), a

	ld a, #1
	ld (proyectil_speed_left), a

	jp fin_init_enemies


	level_4:

	;; Solo enemigo y flechas derecha
	xor a
	ld (cont_right), a
	ld a, #10
	ld (cont_time_enemies), a

	;; EL enemigo se mueve de 4 en 4 píxeles
	ld a, #-3
	ld (proyectil_speed), a

	jp fin_init_enemies


	level_5:

	;; Todo (regular velocidad)
	xor a
	ld (cont_right), a
	ld (cont_left), a
	ld a, #25
	ld (cont_time_enemies), a
	ld a, #18
	ld (cont_time_enemies_left), a
	
	;; EL enemigo se mueve de 4 en 4 píxeles
	ld a, #-3
	ld (proyectil_speed), a

	ld a, #1
	ld (proyectil_speed_left), a

	jp fin_init_enemies


	level_6:

	;; Todo (rapido)
	;; Todo (regular velocidad)
	xor a
	ld (cont_right), a
	ld (cont_left), a
	ld a, #10
	ld (cont_time_enemies), a
	ld a, #40
	ld (cont_time_enemies_left), a
	
	;; EL enemigo se mueve de 4 en 4 píxeles
	ld a, #-3
	ld (proyectil_speed), a

	ld a, #3
	ld (proyectil_speed_left), a


	jp fin_init_enemies


	level_7:

	;; Todo muy rapido
	xor a
	ld (cont_right), a
	ld (cont_left), a
	ld a, #31
	ld (cont_time_enemies), a
	ld a, #20
	ld (cont_time_enemies_left), a
	
	;; EL enemigo se mueve de 4 en 4 píxeles
	ld a, #-5
	ld (proyectil_speed), a

	ld a, #2
	ld (proyectil_speed_left), a

	jp fin_init_enemies


	fin_init_enemies:

	;; Inicializar vector si es necesario
	call man_reset_vector
	call man_entity_init
	call reset_tilemap_ptr
	call reset_MaxSize

	switch_end:

	ret

;; Segun el nivel en el que se encuentra el jugador, se generarán una seria de enemigos
;; REGISTROS ALTERADOS: A, HL, DE, BC, IX 
update_enemies_level::
	
	;3044
	ld a, e_x(ix)
	cp #0x40

	jp z, next_level

	call man_pointer_first_enemy

	call dec_timer
	cp #-1

	jp z, restart_game

	call update_timer
	call update_life
	
	call get_actual_level
	cp #1
	jr z, update_level_1
	cp #2
	jr z, update_level_2
	cp #3
	jr z, update_level_3
	cp #4
	jr z, update_level_4
	cp #5
	jr z, update_level_5
	cp #6
	jr z, update_level_6
	cp #7
	jr z, update_level_7

	jp update_enemies_end

	update_level_1:
	;call proyectiles_derecha
	jp update_enemies_end

	update_level_2:
	call proyectiles_derecha
	jp update_enemies_end

	update_level_3:
	call proyectiles_derecha
	call proyectiles_izquierda
	jp update_enemies_end

	update_level_4:

	call man_entity_getArray
	ld bc, #entity_size
	add ix, bc

	ld e_draw(ix), #on

	add ix, bc

	ld e_draw(ix), #on

	call proyectiles_derecha
	jp update_enemies_end

	update_level_5:

	call man_entity_getArray
	ld bc, #entity_size
	add ix, bc

	ld e_draw(ix), #on

	add ix, bc

	ld e_draw(ix), #on

	call proyectiles_derecha
	call proyectiles_izquierda

	jp update_enemies_end

	update_level_6:

	call man_entity_getArray
	ld bc, #entity_size
	add ix, bc

	ld e_draw(ix), #on

	add ix, bc

	ld e_draw(ix), #on

	call proyectiles_derecha
	call proyectiles_izquierda
	jp update_enemies_end

	update_level_7:

	call man_entity_getArray
	ld bc, #entity_size
	add ix, bc

	ld e_draw(ix), #on

	add ix, bc

	ld e_draw(ix), #on

	call proyectiles_derecha
	call proyectiles_izquierda
	jp update_enemies_end

	update_enemies_end:

	ret

	restart_game:

	call restart_actual_level

	call game_over
	call start_game

	next_level:

	call get_actual_level
	cp #7

	jr z, reset_level

	call increment_actual_level

	jp continue_reset

	reset_level:

	call restart_actual_level

	continue_reset:	

	call game_over
	call start_game

	ret

;; Si el contador es 0, significa que hay que generar un nuevo proyectil e introducirlo en el vector de entidades
;; sino se decrementa la variable contador
;; REGISTROS ALTERADOS: A, HL, DE, BC, IX
proyectiles_derecha:
	
	ld a, (cont_right)
	cp #0

	jr z, continuar_derecha

	;; Decermentar
	dec a
	ld (cont_right), a

	jp no_push_proyectil_derecha

	continuar_derecha:

	ld a, (cont_time_enemies)
	ld (cont_right), a

	;; Generar proyectil derecha
	ld hl, #proyectilDerecha
	call push_proyectil

	no_push_proyectil_derecha:

	ret

proyectiles_izquierda:
	
	ld a, (cont_left)
	cp #0

	jr z, continuar_izquierda

	;; Decermentar
	dec a
	ld (cont_left), a

	jp no_push_proyectil_izquierda

	continuar_izquierda:

	ld a, (cont_time_enemies_left)
	ld (cont_left), a

	;; Generar proyectil izquierda
	ld hl, #proyectilIzquierda
	call push_proyectil

	no_push_proyectil_izquierda:

	ret

;; Si el númeor máximo de entidades en el vecctor nos lo permite, colocamos porocedemos a colocar a crear el proyectil
;; REGISTROS ALTERADOS: A, HL, DE, BC, IX
push_proyectil:

	;ld (init_entity), hl		;; Guardar l el puntero a la primera entidad donde queremos copiar los datos
	
	;ld a, (_entity_num)
	call man_entity_getNumEntitites
	cp #max_entities
	jr z, cancelar_push

	;ld d, h
	;ld e, l

    ;ld__ixh_d
    ;ld__ixl_e

  	;ld a, e_state(ix)

	;; Creamos la entidad y la metemos en el array de entidades
	call man_entity_create


	;ld b, #0x10
	;sub b

	;jp m, push_down

	;ld e_y(ix), #04

	;push_down:



	;; INcremento en número de entidades creeadas
	;ld a, (_entity_num)
	;inc a
	;ld (_entity_num), a

	; Creamos una nueva entidad (aquí el puntero apuntará a la siguiente entidad, pero nos hemos guardado la anterior en HL para copiar los datos)
	;call new_enemy
	;ex de, hl 	;; Guarod en DE el puntero a la siguiente entidad (a la siguiete que se creará)

	;ld ix, #0x0000
	;add ix, de

	;new_entity = . + 1
	;ld hl, #new_entity
	;call copy_enemy

	;ld hl, #new_entity
	;ld (last_elem_pointer), hl

	;; Modificar valores proyectil (si es necesario)
	;;call modify_enemy


	cancelar_push:

	ret


enemy_array_collision_wall:

	call check_collision_wall
	ld a, c

	ret

enemy_array_collision_player:

	call check_collision_player
	
	ret

update_enemy_array:
	
	;; Hacer bucle
	;; Cambiar ya que esto siempre apunta a la primera entidad del vector, pero nuestra primera entidad será el jugador
	;; así que hay que apuntar a la segunda
	;call man_pointer_init	;; Cambiar	
	;call man_pointer_first_enemy	;; *

	;; DE = puntero primera entidad
	;call man_entity_getInt_Pend	;; Cambiar
	;; A = nº de entidades en el vector actualmente
	;call man_entity_getNumEntitites
	;call man_entity_getNumEnemies	;; *
	;cp #0

	;jr nz, loop_collision

	;jr end_loop_collision

	loop_collision:
	
	push af

	ld__ixh_d
    ld__ixl_e

    ;; Colisión con player
	call enemy_array_collision_player
	cp #0

	jr nz, collision_enemy

    ;; Colisión con pared opuesta
	call enemy_array_collision_wall
	cp #0

	jr z, no_collision_wall

	ld h, d
	ld l, e

	;; Borrar
	call man_delete_entity

	pop af

	dec a

	jr z, no_enemies

	no_enemies:

	call man_entity_setNumEntities	;; *

	call man_entity_refresh_pend

	ret

	call man_pointer_first_enemy	;; *
	;call man_entity_getInt_Pend	;; Cambiar
	ld h, d
	ld l, e

	ex de, hl

	call man_entity_getNumEnemies

	jr loop_collision

	no_collision_wall:

	ld e_x(ix), b

	pop af

	dec a

	;ld (_entity_num), a

	ret z

	continue_checking:

	ld bc, #entity_size
	ex de, hl
	add hl ,bc
	ld d, h
	ld e, l

	;call man_entity_getNumEnemies

	jr loop_collision

	collision_enemy:

	call man_delete_entity

	pop af
	dec a
	push af

	call man_entity_getNumEnemies
	dec a


	call man_entity_setNumEntities	;; *

	call man_entity_refresh_pend

	call man_pointer_init

	ld a, e_life(ix)
	dec a

	cp #0

	jr z, dead_player 

	ld e_life(ix), a 	

	;call man_entity_getNumEnemies
	pop af
	cp #0

	jr z, end_loop_collision

	jp loop_collision

	dead_player:
	call restart_actual_level
	;call reset_tilemap_ptr
	;call reset_MaxSize
	call game_over
	call start_game

	;jr end_loop_collision

	;jr loop_collision

	end_loop_collision:

	ret

update_bomb:

    call enemy_array_collision_player
    cp #0

    jr z, end_update_bomb 

    ld a, e_life(iy)
	dec a
	ld e_life(iy), a

	jr nz, stay_alive

	jr z, dead_player  

	jp end_update_bomb

	stay_alive:

	call man_entity_getInt_Pend
	ld (player_entity), de
	player_entity = . + 2
	ld iy, #0x0000
	ld bc, #entity_size

	add iy, bc

	ld (bomb_entity), iy
	bomb_entity = . + 2
	ld ix, #0x0000

	add ix, bc

	call set_standby_delay_one

	call ai_control_stand_by

    end_update_bomb:

	ret

;; Llamar game_manager
rutine_array_enemies::

	call man_pointer_first_enemy	;; *

	;; DE = puntero primera entidad
	;call man_entity_getInt_Pend	;; Cambiar
	;; A = nº de entidades en el vector actualmente
	;call man_entity_getNumEntitites
	call man_entity_getNumEnemies	;; *
	cp #0

	jr nz, continue_rutine

	jr end_rutine_array_enemies

	continue_rutine:
	
	call update_enemy_array

	end_rutine_array_enemies:

	call man_entity_getInt_Pend
	ld h, d
	ld l, e
	ld bc, #entity_size

	add hl, bc

	ex de, hl

	ld__ixh_d
    ld__ixl_e

    ld a, e_draw(ix)
    cp #on

    jr nz, no_update_bomb

    call update_bomb

    no_update_bomb:

	ret

;move_enemy:
	
;	ld a, e_vx(ix)
;	cp #0

;	jp m, move_left

;	ld a, e_x(ix)
;	sub e_vx(ix)
;	ld e_x(ix), a

;	move_left:

;	ld a, e_x(ix)
;	add e_vx(ix)
;	ld e_x(ix), a

;	ret


;delete_enemy:
	
;	ld a, (max_num_entities)
;	cp #0

;	jr z, cancel_delete

;	sub a
;	ld (max_num_entities), a

	;; Guardo la entidad borrada
;	ld (deleted_entity), ix
;	ld hl, (last_elem_pointer)
;	ld bc, #entity_size_enemies
;	or a
;	sbc hl, bc
;	ld (last_elem_pointer), hl

;	ld hl, (last_elem_pointer)
;	deleted_entity = . + 1
;	ld de, #0x0000
;	call copy_enemy

;	cancel_delete:

;	ret