;;This file is part of Project Thing.
;;
;;Project Thing is free software: you can redistribute it and/or modify
;;it under the terms of the GNU General Public License as published by
;;the Free Software Foundation, either version 3 of the License, or
;;(at your option) any later version.
;;
;;Project Thing is distributed in the hope that it will be useful,
;;but WITHOUT ANY WARRANTY; without even the implied warranty of
;;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;GNU General Public License for more details.
;;
;;You should have received a copy of the GNU General Public License
;;along with Project Thing.  If not, see <https://www.gnu.org/licenses/>.


.macro DefineEntity _name, _x, _y, _h, _w, _vx, _vy , _sprite, _lastPosPtr, _state, _life, _ai_state, _animation_ptr, _animation_state, _draw
    _name:
        .db _x
        .db _y
        .db _h
        .db _w
        .db _vx
        .db _vy
        .dw _sprite
        .dw _lastPosPtr
        .db _state
        .db _life
        .db _ai_state
        .dw _animation_ptr
        .db _animation_state
        .db _draw
.endm

e_x=0
e_y=1
e_h=2
e_w=3
e_vx=4
e_vy=5
e_sprite_l = 6
e_sprite_h = 7
e_lp_l = 8
e_lp_h = 9
e_state = 10
e_life = 11
e_ai_state = 12
e_animation_ptr_l = 13
e_animation_ptr_h = 14
e_animation_state = 15
e_draw = 16
sizeof_e= 17


;;Player states
standing = 0
jumping = 1
crouched = 2
enemy_noIA = 3
enemy_noIA_bomb = 4

;;ai_states
ai_no_ai = 0
ai_stand_by = 1
ai_destroy = 2
ai_seek = 3
ai_bomb_held = 4
ai_bomb_dropped = 5

;;animation_states
anim_no_anim = 0
anim_idle = 1
anim_walking_right = 2
anim_walking_left = 3
anim_jumping = 4

;; e_draw
on = 0
off = 1


.macro DefineEntityDefault _name, _n
    DefineEntity _name'_n, #0, #0, #0, #0, #0, #0, #0, #0, #0, #0, #0, #0, #0, #0
.endm

.macro DefineEntityArray _name, _N
    _c = 0
    .rept _N
        DefineEntityDefault _name, \_c
        _c= _c + 1
    .endm
.endm

.globl man_entity_getArray
.globl man_entity_create
.globl entity_size
.globl man_entity_init

.globl man_delete_entity
.globl man_entity_refresh_pend
.globl max_entities

.globl man_pointer_first_enemy
.globl man_entity_getNumEnemies
.globl man_entity_setNumEntities
.globl man_entity_getNumEntitites

.globl man_entity_getInt_Pend

.globl man_reset_vector

.globl man_pointer_init

.globl restart_actual_level

nullptr == 0x0000
.globl increment_actual_level
.globl get_actual_level
