;;This file is part of Project Thing.
;;
;;Project Thing is free software: you can redistribute it and/or modify
;;it under the terms of the GNU General Public License as published by
;;the Free Software Foundation, either version 3 of the License, or
;;(at your option) any later version.
;;
;;Project Thing is distributed in the hope that it will be useful,
;;but WITHOUT ANY WARRANTY; without even the implied warranty of
;;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;GNU General Public License for more details.
;;
;;You should have received a copy of the GNU General Public License
;;along with Project Thing.  If not, see <https://www.gnu.org/licenses/>.

;;
;;Game Manager
;;

.include "game_manager.h.s"
.include "enemy.h.s"
.include "render_system.h.s"
.include "timer.h.s"
.include "assets.h.s"

;;.include "animations.s"
; _x, _y, _h, _w, _vx, _vy , _sprite, _lastPosPtr, _state, _life, _ai_state, _animation_ptr, _animation_state, _draw
DefineEntity player, 20, #0x88, 32, 8, 0, 0, _personajes_2, 0xC000, 0, 3, ai_no_ai, _thing_idle, anim_idle, on
DefineEntity bomb, 32, 36, 8, 4, 0, 0, _Bomba1, 0xC000, 0, -1, ai_bomb_held, nullptr, anim_no_anim, off
DefineEntity enemy, 30, 28, 16, 8, 0, 0, _Marinero1, 0xC000, 0, -1, ai_stand_by, nullptr, anim_no_anim, off


start_game::
   call draw_colorfondo
   call inputsys_waitForInput
   cp #0
   ld    c, #00
   call cpct_setVideoMode_asm

   ld de, #_menu_song
   call cpct_akp_musicInit_asm

   ld hl, #_palette   
   ld de, #16
   call cpct_setPalette_asm
   
   call init_enemies_level

   ld hl, #player
   call man_entity_create
   ld hl, #bomb
   call man_entity_create
   ld hl, #enemy
   call man_entity_create
   call man_entity_getArray
   call rendersys_init
   call man_entity_getArray
   call ai_control_init
   
   ld a, #string_Init
   call draw_pantalla_inicio

   ;;Hay que mostrar por pantalla un mensaje de inicio y despues borrarlo

_wait_to_start:
   call cpct_waitVSYNC_asm

    call inputsys_waitForInput
    cp #0

    jr z, _wait_to_start
    call draw_colorfondo
    jr game_loop_intro


game_loop_intro:
   ld de, #_game_song
   call cpct_akp_musicInit_asm
game_loop:

   call man_entity_getArray   
   call update_enemies_level
   call rutine_array_enemies

   call man_entity_getArray
   call inputsys_update

   call man_entity_getArray
   call ai_control_update

   call man_entity_getArray
   call animation_update

   call man_entity_getArray
   call phy_update

   call map_update
   
   call man_entity_getArray
   call rendersys_update
   call draw_suelo
   call reset_posicion_pantalla_y_max_pantalla
   
   call setdraw_tilemap
   call map_getVideoPtr
   ex de, hl
   call draw_tilemap

   call draw_door

   call cpct_waitVSYNC_asm

   call map_switchBuffers
   
   jr game_loop