;;This file is part of Project Thing.
;;
;;Project Thing is free software: you can redistribute it and/or modify
;;it under the terms of the GNU General Public License as published by
;;the Free Software Foundation, either version 3 of the License, or
;;(at your option) any later version.
;;
;;Project Thing is distributed in the hope that it will be useful,
;;but WITHOUT ANY WARRANTY; without even the implied warranty of
;;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;GNU General Public License for more details.
;;
;;You should have received a copy of the GNU General Public License
;;along with Project Thing.  If not, see <https://www.gnu.org/licenses/>.

;;
;;Input System
;;

.include "cpctelera.h.s"
.include "entity_manager.h.s"
.include "assets.h.s"
;;System that will read the keys the user is presing and modify the player's character attributes acordingly

.globl cpct_scanKeyboard_f_asm
.globl cpct_isKeyPressed_asm
.globl cpct_isAnyKeyPressed_f_asm

;; 1 = NO puedo moverme / 0 = SI puedo moverme
move:: .db #00

get_input_move::
    
    ld a, (move)

    ret

inputsys_init::
    ret


;;lee el teclado y espera a que se presione cualquier tecla para devolver 1 en cualquer otro caso devuelve 0
inputsys_waitForInput::
    ;;Scan Keys
    call cpct_scanKeyboard_f_asm

    ;;If SPACE key pressed
    ld hl, #Key_Space
    call cpct_isKeyPressed_asm
    jr nz, _pressed
    ld hl, #Joy0_Fire1
    call cpct_isKeyPressed_asm
    jr z, _notPressed
_pressed:
    ld a, #1
    ;;Devuelve algo enun registro
    jr _end_if
_notPressed:
    ld a, #0

_end_if:
    ret


inputsys_update::

    ;;Check if character state is diferent from standing
    ld a, e_state(ix)
    ;;If character state is jumping
    cp #jumping
    jp z, _endInput

    ;;If charcter state is crouched
    ;cp #crouched
    ld a, (move)
    cp #00
    jr z, _begin
    jr _crouched_player

_begin:
    ;;reset velocity and state
    ld e_vx(ix), #0 ;;x_speed
    ;;ld e_vy(ix), #0 ;;y_speed


    ;;Scan Keys
    call cpct_scanKeyboard_f_asm

    ;;If A pressed(Crouched)
    ld hl, #Key_A
    call cpct_isKeyPressed_asm
    jr nz, _pressed_A
    ld hl, #Joy0_Down
    call cpct_isKeyPressed_asm
    jr z, _notPressed_A
_pressed_A:
    ;;if a is pressed the player will crouch
    ld a, #16
    ld e_h(ix), a

    ld a, #08
    ld e_w(ix), a

    ld hl, #_Thing_agachado1
    ld e_sprite_h(ix), h
    ld e_sprite_l(ix), l

    ld a, #0x98 
    ld e_y(ix), a
    ld e_state(ix), #crouched
    ld a, #01
    ld (move), a
    ;ld a, e_y(ix)
    ;add #15
    ;ld e_y(ix), a
    ;ld e_h(ix), #16
    ;ld e_state(ix), #crouched
    ;ld e_vy(ix), #4
    
    ;ret
    jp _endInput  

_crouched_player:
     call cpct_scanKeyboard_f_asm
    ;;If A pressed(Crouched)
    ld hl, #Key_A
    call cpct_isKeyPressed_asm
    jr nz, _endInput
    ld hl, #Joy0_Down
    call cpct_isKeyPressed_asm
    jr nz, _endInput
_reset_state:
    ;;If state crouched and A is no pressed reset player size
    ld a, #32
    ld e_h(ix), a

    ld a, #0x88
    ld e_y(ix), a
    ld e_vy(ix), #1
    ld e_state(ix), #standing
    ld a, #00
    ld (move), a
    ;ld a, e_y(ix)
    ;sub #17
    ;ld e_y(ix), a
    ;ld e_h(ix), #32
    ;ld e_state(ix), #standing

    ;ret
    jp _endInput

    _notPressed_A:

    ;;If O pressed
    ld hl, #Key_O
    call cpct_isKeyPressed_asm
    jr nz, _pressed_O
    ld hl, #Joy0_Left
    call cpct_isKeyPressed_asm
    jr z, _notPressed_O
_pressed_O:
    ld e_vx(ix), #-1
_notPressed_O:

    ;;If P pressed
    ld hl, #Key_P
    call cpct_isKeyPressed_asm
    jr nz, _pressed_P
    ld hl, #Joy0_Right
    call cpct_isKeyPressed_asm
    jr z, _notPressed_P
_pressed_P:
    ld e_vx(ix), #1
_notPressed_P:

    ;;If Q pressed(Jump)
    ld hl, #Key_Q
    call cpct_isKeyPressed_asm
    jr nz, _pressed_Q
    ld hl, #Joy0_Up
    call cpct_isKeyPressed_asm
    jr z, _notPressed_Q
_pressed_Q:
    ld e_state(ix), #jumping
    ld e_vy(ix), #-8
_notPressed_Q:




    _endInput:

    ret

