;;This file is part of Project Thing.
;;
;;Project Thing is free software: you can redistribute it and/or modify
;;it under the terms of the GNU General Public License as published by
;;the Free Software Foundation, either version 3 of the License, or
;;(at your option) any later version.
;;
;;Project Thing is distributed in the hope that it will be useful,
;;but WITHOUT ANY WARRANTY; without even the implied warranty of
;;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;GNU General Public License for more details.
;;
;;You should have received a copy of the GNU General Public License
;;along with Project Thing.  If not, see <https://www.gnu.org/licenses/>.


.include "game_manager.h.s"

.area _DATA
.area _CODE

.globl cpct_disableFirmware_asm


_music_counter: .db 6
int_handler::
   push af
   push bc
   push de
   push hl
   push ix
   push iy

   ld a, (_music_counter)
   dec a
   jr nz, _no_play_music
_play_music:
   call cpct_akp_musicPlay_asm
   ld a, #6
_no_play_music:
   ld (_music_counter), a

   pop iy
   pop ix
   pop hl
   pop de
   pop bc
   pop af

   ei
   reti


set_int_handler:
   ld hl, #0x38
   ld (hl), #0xC3
   inc hl
   ld (hl), #<int_handler
   inc hl
   ld (hl), #>int_handler
   inc hl
   ld (hl), #0xC9
   ret


_main::
   cpctm_setBorder_asm HW_BLACK
   ;; Disable firmware to prevent it from interfering with string drawing
   ld de, #_menu_song
   call cpct_akp_musicInit_asm
   call cpct_disableFirmware_asm
   call set_int_handler
   call start_game

