;;This file is part of Project Thing.
;;
;;Project Thing is free software: you can redistribute it and/or modify
;;it under the terms of the GNU General Public License as published by
;;the Free Software Foundation, either version 3 of the License, or
;;(at your option) any later version.
;;
;;Project Thing is distributed in the hope that it will be useful,
;;but WITHOUT ANY WARRANTY; without even the implied warranty of
;;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;GNU General Public License for more details.
;;
;;You should have received a copy of the GNU General Public License
;;along with Project Thing.  If not, see <https://www.gnu.org/licenses/>.

;;
;;PHYSICS SYSTEM
;;

.include "entity_manager.h.s"
.include "physics_system.h.s"
.include "input_system.h.s"


;; Updates the position of entities by adding their speed to their position
;;  IX: Pointer to first entity
;;   A: number of entities to update

phy_update::

    ld a, #03   ;; Solo tenemos las tres primeras entidades que usan este sismtema

    push af

    call get_input_move
    cp #00

    jr nz, _next_entity

   ; pop af

_phyloop:

    ;;Updates y
    ld a, #screen_heigth + 1
    sub e_h(ix)
    ld c, a

    
    ;;If entity is number 2 (enemy) don't apply gravity
    ld a, e_ai_state(ix)
    cp #ai_no_ai
    jr nz, _endif_y

    ;;Apply gravity
_apply_gravity:
    ld a, e_vy(ix)
    add #gravity
    ld e_vy(ix), a

    ld  a, e_y(ix)    ;;y
    add e_vy(ix)
    cp c

    jr nc, _invalid_y

_valid_y:
    ld  e_y(ix), a
    jr _endif_y

_invalid_y:
    ld e_state(ix), #standing
    ld e_vy(ix), #0

_endif_y:

    ;;Updates x
    ld a, #screen_width + 1
    sub e_w(ix)
    ld c, a


    ld  a, e_x(ix)    ;;x
    add e_vx(ix)
    cp c

    jr nc, _invalid_x

_valid_x:
    ld  e_x(ix), a
    jr _endif_x

_invalid_x:
    ld a, e_vx(ix)
    neg
    ld e_vx(ix), a

_endif_x:

    ld a, e_ai_state(ix)
    cp #ai_no_ai
    jr z, _endif_drift

    ld e_vx(ix), #0
_endif_drift:
    
_next_entity:

    pop af

    dec a
    ret z

    push af

    ld bc, #entity_size
    add ix, bc
    jr _phyloop

_end:

ret